﻿'***************************************************************************************************
'   配属一覧サンプル(MDB及びテーブル情報)                       modSampleCorp1MDB(Module)
'
'   作成者:井上治  URL:https://www.ne.jp/asahi/excel/inoue/ [Excelでお仕事!]
'***************************************************************************************************
' 変更日付 Rev     変更履歴内容-------------------------------------------------------------------->
' 17/01/22(1.0.1.0)新規作成
' 17/03/11(1.0.1.0)ACCDBでの変更箇所をコメントで追加する対応
'***************************************************************************************************
Module modSampleCorp1MDB
    '===============================================================================================
    ' MDBファイル情報
    Friend Const g_cnsMdbFileame As String = "SampleCorp1.mdb"
    'Friend Const g_cnsMdbFileame As String = "SampleCorp1.accdb" ' ←ACCDBの場合
    Friend Const g_cnsMdbSubFolder As String = "SampleMDB"
    ' テーブルID
    Friend Const g_cnsMST_BUSYO As String = "[MST_BUSYO]"           ' 部署マスタ
    Friend Const g_cnsMST_YAKU As String = "[MST_YAKU]"             ' 役職マスタ
    Friend Const g_cnsMST_SYAIN As String = "[MST_SYAIN]"           ' 社員マスタ
    Friend Const g_cnsMST_HAIZOKU As String = "[MST_HAIZOKU]"       ' 配属マスタ
    '-----------------------------------------------------------------------------------------------
    ' 各テーブルのフィールドIDテーブル
    ' 部署マスタ
    Friend ReadOnly g_tblFld_MST_BUSYO() As String = {"[BUSYO_CD]", "[BUSYO_NM]"}
    ' タイプ(0=文字, 1=数値(整数), 2=数値(実数), 2=Bool, 5=日付, 6=時刻, 8=文字列(要変換), 9=他)
    Friend ReadOnly g_tblFldTyp_MST_BUSYO() As Integer = {0, 8}
    '-------------------------
    ' 役職マスタ
    Friend ReadOnly g_tblFld_MST_YAKU() As String = {"[YAKU_CD]", "[RANK1]", "[RANK2]", "[YAKU_NM]"}
    ' タイプ(0=文字, 1=数値(整数), 2=数値(実数), 2=Bool, 5=日付, 6=時刻, 8=文字列(要変換), 9=他)
    Friend ReadOnly g_tblFldTyp_MST_YAKU() As Integer = {0, 0, 0, 8}
    '-------------------------
    ' 社員マスタ
    Friend ReadOnly g_tblFld_MST_SYAIN() As String = _
        {"[SCD]", "[KANJI_SEI]", "[KANJI_MEI]", "[KANA_SEI]", "[KANA_MEI]", "[SEX]", _
         "[SEINEN_YMD]", "[NYUSYA_YMD]", "[TAISYOKU_YMD]"}
    ' タイプ(0=文字, 1=数値(整数), 2=数値(実数), 2=Bool, 5=日付, 6=時刻, 8=文字列(要変換), 9=他)
    Friend ReadOnly g_tblFldTyp_MST_SYAIN() As Integer = {0, 8, 8, 8, 8, 0, 5, 5, 5}
    '-------------------------
    ' 配属マスタ
    Friend ReadOnly g_tblFld_MST_HAIZOKU() As String = _
        {"[SCD]", "[KAISHI_YMD]", "[SYURYO_YMD]", "[BUSYO_CD]", "[YAKU_CD]"}
    ' タイプ(0=文字, 1=数値(整数), 2=数値(実数), 2=Bool, 5=日付, 6=時刻, 8=文字列(要変換), 9=他)
    Friend ReadOnly g_tblFldTyp_MST_HAIZOKU() As Integer = {0, 5, 5, 0, 0}
    '-------------------------

    '----------------------------------------<< End of Source >>------------------------------------
End Module
